Attribute VB_Name = "modAutostart"
' **************************************'***************************************
' ** Name:         modAutostart                                              **
' ** Datum:        13.11.2004                                                     **
' ** Autor:        Gerhard Brandl                                             **
' ** Prozeduren:                                                              **
' ** Bemerkung:                                                               **
' **************************************'***************************************

Option Explicit
'zunchst die bentigten API-Deklarationen
Private Declare Function RegOpenKeyEx Lib "advapi32.dll" _
  Alias "RegOpenKeyExA" (ByVal hKey As Long, _
  ByVal lpSubKey As String, ByVal ulOptions As Long, _
  ByVal samDesired As Long, phkResult As Long) As Long

Private Declare Function RegCloseKey Lib "advapi32.dll" _
  (ByVal hKey As Long) As Long

Private Declare Function RegSetValueEx_String Lib _
  "advapi32.dll" Alias "RegSetValueExA" (ByVal hKey _
  As Long, ByVal lpValueName As String, ByVal Reserved _
  As Long, ByVal dwType As Long, ByVal lpData As String, _
  ByVal cbData As Long) As Long

Private Declare Function RegDeleteValue Lib _
  "advapi32.dll" Alias "RegDeleteValueA" (ByVal hKey As _
  Long, ByVal lpValueName As String) As Long

Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002

Public Const HKEY_CLASSES_ROOT As Long = &H80000000

Private Declare Function RegQueryValueEx Lib "advapi32.dll" _
  Alias "RegQueryValueExA" ( _
  ByVal hKey As Long, _
  ByVal lpValueName As String, _
  ByVal lpReserved As Long, _
  lpType As Long, _
  lpData As Any, _
  lpcbData As Any) As Long
  
Const KEY_QUERY_VALUE = &H1
Const KEY_SET_VALUE = &H2
Const KEY_CREATE_SUB_KEY = &H4
Const KEY_ENUMERATE_SUB_KEYS = &H8
Const KEY_NOTIFY = &H10
Const KEY_CREATE_LINK = &H20
Const KEY_ALL_ACCESS = KEY_QUERY_VALUE Or KEY_SET_VALUE _
  Or KEY_CREATE_SUB_KEY Or KEY_ENUMERATE_SUB_KEYS Or _
  KEY_NOTIFY Or KEY_CREATE_LINK
Private Const KEY_READ = KEY_QUERY_VALUE Or _
  KEY_ENUMERATE_SUB_KEYS Or KEY_NOTIFY
Private Const REG_DWORD = 4

Const ERROR_SUCCESS = 0&

Const REG_NONE = 0
Const REG_SZ = 1

'Anwendung in Registry eintragen
'
'sDescr:  Beschreibung/Bezeichnung
'sPath :  Pfad inkl. Dateiname der Anwendung
'===========================================
Public Function SetAutoRun(sDescr As String, _
  sPath As String) As Boolean

  Dim lResult As Long
  Dim KeyHandle As Long
  Dim Key As String

  Const root = HKEY_CURRENT_USER
  Key = "SOFTWARE\Microsoft\Windows\CurrentVersion\Run"

  lResult = RegOpenKeyEx(root, Key, 0, KEY_ALL_ACCESS, _
    KeyHandle)
  If lResult <> ERROR_SUCCESS Then
    SetAutoRun = False
    Exit Function
  End If

  '+1 fr die Null am Ende
  lResult = RegSetValueEx_String(KeyHandle, sDescr, 0, _
    REG_SZ, sPath, Len(sPath) + 1)

  RegCloseKey KeyHandle
  SetAutoRun = (lResult = ERROR_SUCCESS)
End Function

'aus Registry entfernen
'
'sDescr:  Beschreibung/Bezeichnung
'=================================
Function RemoveAutoRun(sDescr As String) As Boolean
  Dim lResult As Long
  Dim KeyHandle As Long
  Dim Key As String
  
  Const root = HKEY_CURRENT_USER
  Key = "SOFTWARE\Microsoft\Windows\CurrentVersion\Run"

  lResult = RegOpenKeyEx(root, Key, 0, _
    KEY_ALL_ACCESS, KeyHandle)
  If lResult <> ERROR_SUCCESS Then
    RemoveAutoRun = False
    Exit Function
  End If
  lResult = RegDeleteValue(KeyHandle, sDescr)
  RemoveAutoRun = (lResult = ERROR_SUCCESS)
  RegCloseKey KeyHandle
End Function

' Wert aus Registry auslesen
Public Function GetValue(ByVal hKey As Long, _
  ByVal sKey As String, _
  ByVal sField As String, _
  vValue As Variant) As Boolean

  Dim nResult As Long
  Dim nKeyOpen As Long
  Dim dwType As Long
  Dim nValue As Long
  Dim nLen As Long
  Dim sBuffer As String

  GetValue = False

  ' Registry-Schlssel ffnen
  nResult = RegOpenKeyEx(hKey, sKey, 0, KEY_READ, nKeyOpen)
  If nResult <> ERROR_SUCCESS Then Exit Function
  
  ' Werte-Typ bestimmen
  nResult = RegQueryValueEx(nKeyOpen, sField, 0&, _
    dwType, ByVal 0&, nLen)
  
  If nResult = ERROR_SUCCESS Then
    Select Case dwType
      Case REG_SZ
        ' String
        sBuffer = Space$(nLen + 1)
        nResult = RegQueryValueEx(nKeyOpen, sField, 0&, _
          dwType, ByVal sBuffer, nLen)
        If nResult = ERROR_SUCCESS Then
          vValue = Left$(sBuffer, nLen - 1)
        End If
    
      Case REG_DWORD
        ' DWord
        nLen = 4
        nResult = RegQueryValueEx(nKeyOpen, sField, 0&, _
          dwType, nValue, nLen)
        If nResult = ERROR_SUCCESS Then vValue = nValue
    End Select

    ' Schlieen
    RegCloseKey nKeyOpen
  End If
  
  GetValue = (nResult = ERROR_SUCCESS)
End Function
