Attribute VB_Name = "modvb6"
' **************************************'***************************************
' ** Name: Verwaltungsprogramm                                                **
' ** Datum: 20.01.03                                                          **
' ** Autor: Gerhard Brandl                                                    **
' ** Modul Name: modvb6                                                       **
' ** Prozeduren: Filter(FilterArray() As String, SourceArray, Match As String,**
' **                    Optional Include As Boolean = True, Optional Compare  **
' **                    As VbCompareMethod = vbBinaryCompare)                 **
' **             InstrRev(StringCheck As String, StringMatch As String,       **
' **                      Optional Start As Long = -1, Optional Compare As    **
' **                      VbCompareMethod = vbBinaryCompare) As Long          **
' **             Join(SourceArray, Optional Delimiter As String) As String    **
' **             Replace(Expression As String, Find As String, Replace1 As    **
' **                     String, Optional Start As Long = 1, Optional Count As**
' **                     Long = 1, Optional Compare As VbCompareMethod =      **
' **                     vbBinaryCompare) As String                           **
' **             Split(SplitArray() As String, Expression As String, Optional **
' **                   Delimiter As String, Optional Limit As Long = -1,      **
' **                   Optional Compare As VbCompareMethod = vbBinaryCompare) **
' **             StrReverse(ByVal Expression As String) As String             **
' ** Bemerkung: Modul fr Hilfreiche Funktionen aus VB 6                      **
' ** Bentigte Fenster:                                                       **
' **************************************'***************************************

Public Sub Filter(FilterArray() As String, SourceArray, Match As String, _
    Optional Include As Boolean = True, _
    Optional Compare As VbCompareMethod = vbBinaryCompare)

' **************************************'***************************************
' **  Filter - Diese Prozedur filtert alle Eintrge aus einem Array, welche   **
' **  nicht den zu Suchenden String haben.                                    **
' **  Parameter: FilterArray() Ausgabe Array                                  **
' **             SourceArray   Eingabe Array                                  **
' **             Match         zu Suchender String                            **
' **             Include                                                      **
' **             Compare       legt die Vergleichsart fest, siehe VB-Hilfe    **
' **************************************'***************************************

Dim tmp
Dim vorkommen%                          ' Gibt di Gre des Ausgaben-Feldes an

  For Each tmp In SourceArray           ' Luft das genze Eingabe-Feld durch
    If InStr(1, tmp, Match, Compare) <> 0 Then
                                        ' berprft ob der Suchstring in dem Feldintrag enthalten ist
      ReDim Preserve FilterArray(vorkommen)
                                        ' Das Ausgabe-Feld wird erhht
      FilterArray(vorkommen) = tmp      ' Zuweisung des Eintrag zum Ausgabe-Feld
      vorkommen% = vorkommen + 1        ' Zhler wird erhht
    End If
  Next
  
End Sub

Public Function InstrRev(StringCheck As String, StringMatch As String, _
    Optional Start As Long = -1, _
    Optional Compare As VbCompareMethod = vbBinaryCompare) As Long
' **************************************'***************************************
' **  InstrRev - wie VB-Befehl Instr nur von Hinten nach vorne                **
' **  Parameter: StringCheck  Durchsuchter Zeichenfolgenausdruck              **
' **             StringMatch  Gesuchter Zeichenfolgenausdruck                 **
' **             Start        Startposition                                   **
' **             VbCompareMethod Vergleichsart                                **
' **************************************'***************************************
Dim posit%
Dim oldposit%
Dim md As Boolean

  If Len(StringMatch) <> 0 Then
    If Start <> -1 Then posit% = Start Else posit% = 0
    oldposit% = 1
    Do While InStr(oldposit, StringCheck, StringMatch, Compare) <> 0
      oldposit% = InStr(oldposit, StringCheck, StringMatch, Compare) + 1
      If Start <> -1 Then
        If Start < oldposit - 2 + Len(StringMatch) Then Exit Do
      End If
      md = True
      posit% = oldposit - 1
    Loop
  Else
    If Start <> -1 Then posit% = Start Else posit% = Len(StringCheck)
  End If
  If posit = Start And Len(StringMatch) <> 0 And md = False Then posit = 0
  InstrRev = posit
  
End Function

Public Function Join(SourceArray, Optional Delimiter As String) As String
' **************************************'***************************************
' **  Join                                                                    **
' **  Parameter: SourceArray                                                  **
' **             Delimiter                                                    **
' **************************************'***************************************
On Error GoTo Fehler

  If IsArray(SourceArray) = False Then Exit Function
  
  Dim tmp
  Dim lastOne%
  Dim currentOne%
  
  lastOne% = UBound(SourceArray)
  For Each tmp In SourceArray
    Join = Join & tmp
    If lastOne <> currentOne Then Join = Join & Delimiter
    currentOne% = currentOne + 1
  Next

Exit Function
Fehler:
  If Err.Number = 9 Then Exit Function ' Fehler "Index auerhalb des Gltigen Bereichs" -> Verlassen der Funktion
End Function

Public Function Replace(Expression As String, Find As String, _
    Replace1 As String, Optional Start As Long = 1, Optional Count As Long = 1, _
    Optional Compare As VbCompareMethod = vbBinaryCompare) As String
' **************************************'***************************************
' **  Replace                                                                 **
' **  Parameter: Expression                                                   **
' **             Find                                                         **
' **             Replace1                                                     **
' **             Start                                                        **
' **             Count                                                        **
' **             Compare                                                      **
' **************************************'***************************************

Dim vorkommen%
Dim tmpExpress$
Dim posit%
Dim oldposit%

  posit% = Start
  vorkommen% = 0
  oldposit% = Start
  lenOfFin% = Len(Find)
  lenofRep% = Len(Replace1)
  lenDist% = lenofRep% - lenOfFin%
  Do While InStr(posit, Expression, Find, Compare) <> 0
    If Count <> 1 Then
      If Count = vorkommen Then Exit Do
    End If
    posit% = InStr(posit, Expression, Find, Compare)
    tmpExpress$ = tmpExpress & Mid$(Expression, oldposit, posit - oldposit) & Replace1
    posit% = posit + lenOfFin
    oldposit% = posit%
    vorkommen% = vorkommen + 1
  Loop
  If posit <> Len(Expression) - 1 Then
    tmpExpress$ = tmpExpress & Mid$(Expression, posit)
  End If
  Replace = tmpExpress
  
End Function

Public Sub Split(SplitArray() As String, Expression As String, _
    Optional Delimiter As String, Optional Limit As Long = -1, _
    Optional Compare As VbCompareMethod = vbBinaryCompare)
' **************************************'***************************************
' **  Split : Splitet einen Zeichenfolge in ein Feld                          **
' **  Parameter: SplitArray = Array wo die Ergebnise gespeichert werden       **
' **             Expression = Zeichenfolge die aufgelst werden soll          **
' **             Delimiter = Zeichen welches die Trennung kennzeichnet        **
' **             Limit = Markiert die maximale Anzahl an Eintrgen            **
' **             Compare                                                      **
' **************************************'***************************************

Dim vorkommen%
Dim posit%
Dim oldposit%
Dim tmpExpress$
Dim lenOfDel%

  posit% = 1
  oldposit% = 1
  vorkommen% = 0
  If Delimiter = "" Then Delimiter = " "
  lenOfDel% = Len(Delimiter)
  If Limit <> 0 Then
    Do While InStr(posit, Expression, Delimiter, Compare) <> 0
      If Limit <> -1 Then
        If Limit = vorkommen + 1 Then Exit Do
      End If
      posit% = InStr(posit, Expression, Delimiter, Compare)
      tmpExpress$ = Mid$(Expression, oldposit, posit - oldposit)
      posit% = posit + lenOfDel
      oldposit% = posit%
      ReDim Preserve SplitArray(vorkommen)
      SplitArray(vorkommen) = tmpExpress
      vorkommen% = vorkommen + 1
    Loop
    If posit <> Len(Expression) - 1 Then
      tmpExpress$ = Mid$(Expression, posit)
      ReDim Preserve SplitArray(vorkommen)
      SplitArray(vorkommen) = tmpExpress
    End If
  End If
 
End Sub

Public Function StrReverse(ByVal Expression As String) As String
' **************************************'***************************************
' **  StrReverse - Kehrt die angegebene Zeichenfolge um                       **
' **  Parameter: Expression  Zeichenfolge die umgedreht werden soll           **
' **  Rckgabe: Die umgedrehte Zeichenfolge                                   **
' **************************************'***************************************

Dim tmpExpress$
Dim i%

  For i = Len(Expression) + 1 To 1 Step -1
    tmpExpress$ = tmpExpress & Mid$(Expression, i, 1)
  Next
  StrReverse = tmpExpress$

End Function
